######################################################################
# SQL-Ledger Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#  Contributors:
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#######################################################################
#
# CHANGE LOG:
#   DS. 2000-07-04  Created
#
#######################################################################


use DBI;
use SL::User;
use SL::Form;


$form = new Form;


if ($form->{action}) {
  
  &{ $form->{action} };

} else {

print qq|Content-type: text/html

<head>
  <title>SQL-Ledger, Version $version - Login</title>
</head>

<body bgcolor="#FBFFE7">

<center>

<a href="http://www.sql-ledger.org" target=_top><img src=sql-ledger.gif border=0></a>
<h1>
Version $version
</h1>

<font size=+1>
This program is free software; you may redistribute it and/or modify
it under the terms of the <a href=doc/COPYING>GNU General Public License</a>
as published by the Free Software Foundation.
<p>
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
<p>


<form method=post action=$form->{script}>

<table>
<tr>
<td>

<table>
<tr>
<th align=right>Name</th><td><input name=login></td>
</tr>

<tr>
<th align=right>Password</th><td><input type=password name=password></td>
</tr>
</table>
</td>

<td>
<input class=submit type=submit name=action value="Login">
</td>
</tr>

<input type=hidden name=path value=$form->{path}>

</table>

</form>
|;

}

# end


sub login {

  $user = new User $memberfile, $form->{login};

  if ($user->login(\%$form, $userspath)) {
    $argv = "login=$form->{login}&password=$form->{password}&path=$form->{path}&action=display";
    exec "./menu.pl", $argv;
  }
}



sub company_logo {
  
  require("$userspath/$form->{login}.conf");
  $locale = new Locale $myconfig{countrycode}, "login";

  $myconfig{address} =~ s/\\n/<br>/g;
  $myconfig{dbhost} = 'localhost' unless $myconfig{dbhost};

  $form->{title} = qq"SQL-Ledger - ".$locale->text('About');
  
  # create the logo screen
  $form->header;
  
  print qq|
<pre>

</pre>
<center>
<a href="http://www.sql-ledger.org" target=_top><img src=sql-ledger.gif border=0></a>
<h1>|.$locale->text('Version').qq| $version</h1>

<pre>

</pre>
|.$locale->text('Licensed to').qq|
<h2>
$myconfig{company}
<br>$myconfig{address}
</h2>

<p>
<table border=0>
<tr><th align=right>|.$locale->text('User').qq|-></th><td>$myconfig{name}</td></tr>
<tr><th align=right>|.$locale->text('Using Database').qq|-></th><td>$myconfig{dbname}</td></tr>
<tr><th align=right>|.$locale->text('Database Host').qq|-></th><td>$myconfig{dbhost}</td></tr>
</table>
|;

}



