######################################################################
# SQL-Ledger Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#  Contributors:
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#######################################################################
#
# menu for text based browsers (lynx)
#
# CHANGE LOG:
#   DS. 2000-07-04  Created
#   DS. 2001-08-07  access control
#
#######################################################################


use SL::Form;


$form = new Form;


if ($form->{action}) {
  require("$userspath/$form->{login}.conf");

  $locale = new Locale $myconfig{countrycode}, "menu";

  &{ $form->{action} };
} else {
  $form->error("action= not defined!");
}

# end of main



sub display {

  foreach $item (split /;/, $myconfig{acs}) {
    $excl{$item} = 1;
  }
  
  @menuorder = ('AR--AR', 'AP--AP', 'Inventory--Inventory', 'General_Ledger--General_Ledger', 'Reports--Reports');
  
  $menu{'AR--AR'} = qq|<li><a href=$form->{script}?path=$form->{path}&action=ar_menu&login=$form->{login}>|.$locale->text('AR').qq|</a>|;
  $menu{'AP--AP'} = qq|<li><a href=$form->{script}?path=$form->{path}&action=ap_menu&login=$form->{login}>|.$locale->text('AP').qq|</a>|;
  $menu{'Inventory--Inventory'} = qq|<li><a href=$form->{script}?path=$form->{path}&action=inventory_menu&login=$form->{login}>|.$locale->text('Inventory').qq|</a>|;
  $menu{'General_Ledger--General_Ledger'} = qq|<li><a href=$form->{script}?path=$form->{path}&action=gl_menu&login=$form->{login}>|.$locale->text('General Ledger').qq|</a>|;
  $menu{'Reports--Reports'} = qq|<li><a href=$form->{script}?path=$form->{path}&action=reports_menu&login=$form->{login}>|.$locale->text('Reports').qq|</a>|;


  $form->{title} = "SQL-Ledger $version";
  
  $form->header;

  print qq|
<h1>$form->{title}</h1>

<ol>|;

  map { print $menu{$_} unless $excl{$_} } @menuorder;

  print qq|
<hr>
<li><a href=login.pl?path=$form->{path}&action=company_logo&login=$form->{login}>|.$locale->text('Version').qq|</a>
<li><a href=mailto:dsimader\@sql-ledger.org?subject=SQL-Ledger%20$version%20/%20Bug%20Report>|.$locale->text('Bug Report').qq|</a>
|;

  unless ($myconfig{acs} =~ /Setup--Setup/) {
    print qq|
<li><a href=am.pl?path=$form->{path}&action=setup_menu&login=$form->{login} target=acc_menu>|.$locale->text('Setup').qq|</a>
</ol>
|;
  }

}


sub ar_menu {

  foreach $item (split /;/, $myconfig{acs}) {
    $excl{$item} = 1;
  }
  
  @menuorder = ('AR--Add_Transaction', 'AR--Receipts', 'AR--Reports', 'AR--AR_Aging', 'AR--Add_Customer', 'AR--Search_Customer', 'AR--Customer_Invoice');

  $menu{'AR--Add_Transaction'} = qq|<li><a href=ar.pl?path=$form->{path}&action=add&login=$form->{login} target=main_window>|.$locale->text('Add Transaction').qq|</a>|;
  $menu{'AR--Reports'} = qq|<li><a href=ar.pl?path=$form->{path}&action=search&nextsub=ar_transactions&login=$form->{login} target=main_window>|.$locale->text('Reports').qq|</a>|;
  $menu{'AR--Add_Customer'} = qq|<li><a href=ct.pl?path=$form->{path}&action=add&db=customer&login=$form->{login} target=main_window>|.$locale->text('Add Customer').qq|</a>|;
  $menu{'AR--Search_Customer'} = qq|<li><a href=ct.pl?path=$form->{path}&action=search&db=customer&login=$form->{login} target=main_window>|.$locale->text('Search Customer').qq|</a>|;
  $menu{'AR--Customer_Invoice'} = qq|<li><a href=is.pl?path=$form->{path}&action=add&login=$form->{login} target=main_window>|.$locale->text('Customer Invoice').qq|</a>|;
  $menu{'AR--Receipts'} = qq|<li><a href=ar.pl?path=$form->{path}&action=search&nextsub=receipts&login=$form->{login} target=main_window>|.$locale->text('Receipts').qq|</a>|;
  $menu{'AR--AR_Aging'} = qq|<li><a href=rp.pl?path=$form->{path}&action=report&title=AR%20Aging&login=$form->{login} target=main_window>|.$locale->text('AR Aging').qq|</a>|;
 
  $form->{title} = $locale->text('AR');
  
  $form->header;
  
  print qq|

<h1>$form->{title}</h1>
<ol>
|;

  map { print $menu{$_} unless $excl{$_} } @menuorder;
  
  print qq|
</ol>
|;

}


sub ap_menu {

  foreach $item (split /;/, $myconfig{acs}) {
    $excl{$item} = 1;
  }

  @menuorder = ('AP--Add_Transaction', 'AP--Payments', 'AP--Reports', 'AP--AP_Aging', 'AP--Add_Vendor', 'AP--Search_Vendor', 'AP--Vendor_Invoice');

  $menu{'AP--Add_Transaction'} = qq|<li><a href=ap.pl?path=$form->{path}&action=add&login=$form->{login} target=main_window>|.$locale->text('Add Transaction').qq|</a>|;
  $menu{'AP--Reports'} = qq|<li><a href=ap.pl?path=$form->{path}&action=search&nextsub=ap_transactions&login=$form->{login} target=main_window>|.$locale->text('Reports').qq|</a>|;
  $menu{'AP--Add_Vendor'} = qq|<li><a href=ct.pl?path=$form->{path}&action=add&db=vendor&login=$form->{login} target=main_window>|.$locale->text('Add Vendor').qq|</a>|;
  $menu{'AP--Search_Vendor'} = qq|<li><a href=ct.pl?path=$form->{path}&action=search&db=vendor&login=$form->{login} target=main_window>|.$locale->text('Search Vendor').qq|</a>|;
  $menu{'AP--Vendor_Invoice'} = qq|<li><a href=ir.pl?path=$form->{path}&action=add&login=$form->{login} target=main_window>|.$locale->text('Vendor Invoice').qq|</a>|;
  $menu{'AP--Payments'} = qq|<li><a href=ap.pl?path=$form->{path}&action=search&nextsub=payments&login=$form->{login} target=main_window>|.$locale->text('Payments').qq|</a>|;
  $menu{'AP--AP_Aging'} = qq|<li><a href=rp.pl?path=$form->{path}&action=report&title=AP%20Aging&login=$form->{login} target=main_window>|.$locale->text('AP Aging').qq|</a>|;
  
  
  $form->{title} = $locale->text('AP');
  
  $form->header;

  print qq|
<h1>$form->{title}</h1>

<ol>
|;

  map { print $menu{$_} unless $excl{$_} } @menuorder;

  print qq|
</ol>
|;

}


sub inventory_menu {

  foreach $item (split /;/, $myconfig{acs}) {
    $excl{$item} = 1;
  }

  @menuorder = ('Inventory--Add_Part', 'Inventory--Add_Service', 'Inventory--Add_Assembly', 'Inventory--Reports', 'Inventory--Merchandise_Received', 'Inventory--Stock_Assembly');

  $menu{'Inventory--Add_Part'} = qq|<li><a href=ic.pl?path=$form->{path}&action=add&item=part&login=$form->{login} target=main_window>|.$locale->text('Add Part').qq|</a>|;
  $menu{'Inventory--Add_Service'} = qq|<li><a href=ic.pl?path=$form->{path}&action=add&item=service&login=$form->{login} target=main_window>|.$locale->text('Add Service').qq|</a>|;
  $menu{'Inventory--Add_Assembly'} = qq|<li><a href=ic.pl?path=$form->{path}&action=add&item=assembly&login=$form->{login} target=main_window>|.$locale->text('Add Assembly').qq|</a>|;
  $menu{'Inventory--Reports'} = qq|<li><a href=ic.pl?path=$form->{path}&action=search&login=$form->{login} target=main_window>|.$locale->text('Reports').qq|</a>|;
  $menu{'Inventory--Merchandise_Received'} = qq|<li><a href=ir.pl?path=$form->{path}&action=add&login=$form->{login} target=main_window>|.$locale->text('Merchandise Received').qq|</a>|;
  $menu{'Inventory--Stock_Assembly'} = qq|<li><a href=is.pl?path=$form->{path}&action=stock_assembly&login=$form->{login} target=main_window>|.$locale->text('Stock Assembly').qq|</a>|;
  
  
  $form->{title} = $locale->text('Inventory');
  
  $form->header;

  print qq|
<h1>$form->{title}</h1>

<ol>
|;

  map { print $menu{$_} unless $excl{$_} } @menuorder;

  print qq|
</ol>
|;

}


sub gl_menu {

  foreach $item (split /;/, $myconfig{acs}) {
    $excl{$item} = 1;
  }

  @menuorder = ('General_Ledger--Add_Transaction', 'General_Ledger--Reports');

  $menu{'General_Ledger--Add_Transaction'} = qq|<li><a href=gl.pl?path=$form->{path}&action=add&login=$form->{login} target=main_window>|.$locale->text('Add Transaction').qq|</a>|;
  $menu{'General_Ledger--Reports'} = qq|<li><a href=gl.pl?path=$form->{path}&action=search&login=$form->{login} target=main_window>|.$locale->text('Reports').qq|</a>|;
  
  $form->{title} = $locale->text('General Ledger');
  
  $form->header;

  print qq|
<h1>$form->{title}</h1>

<ol>
|;

  map { print $menu{$_} unless $excl{$_} } @menuorder;

  print qq|
</ol>
|;

}


sub reports_menu {

  foreach $item (split /;/, $myconfig{acs}) {
    $excl{$item} = 1;
  }

  @menuorder = ('Reports--Chart_of_Accounts', 'Reports--Trial_Balance', 'Reports--Income_Statement', 'Reports--Balance_Sheet');

  $menu{'Reports--Chart_of_Accounts'} = qq|<li><a href=ca.pl?path=$form->{path}&login=$form->{login} target=main_window>|.$locale->text('Chart of Accounts').qq|</a>|;
  $menu{'Reports--Trial_Balance'} = qq|<li><a href=rp.pl?path=$form->{path}&action=report&title=Trial%20Balance&login=$form->{login} target=main_window>|.$locale->text('Trial Balance').qq|</a>|;
  $menu{'Reports--Income_Statement'} = qq|<li><a href=rp.pl?path=$form->{path}&action=report&title=Income%20Statement&login=$form->{login} target=main_window>|.$locale->text('Income Statement').qq|</a>|;
  $menu{'Reports--Balance_Sheet'} = qq|<li><a href=rp.pl?path=$form->{path}&action=report&title=Balance%20Sheet&login=$form->{login} target=main_window>|.$locale->text('Balance Sheet').qq|</a>|;

  
  $form->{title} = $locale->text('Reports');
  
  $form->header;

  print qq|
<h1>$form->{title}</h1>

<ol>
|;

  map { print $menu{$_} unless $excl{$_} } @menuorder;

  print qq|
</ol>
|;

}


