#=====================================================================
# SQL-Ledger Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#  Contributors:
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#======================================================================
#
# administration
#
# CHANGE LOG:
#   DS. 2000-07-04  Created
#
#======================================================================


use DBI;
use SL::AM;
use SL::CA;
use SL::Form;
use SL::User;


$form = new Form;


if ($form->{action}) {
  require("$userspath/$form->{login}.conf");
  $myconfig{dbpasswd} = unpack 'u', $myconfig{dbpasswd};
  unless ($form->{action} eq "save_preferences") {
    map { $form->{$_} = $myconfig{$_} } qw(stylesheet charset);
  }

  $locale = new Locale $myconfig{countrycode}, "am";
  &{ $locale->findsub($form->{action}) };
} else {
  $form->error("action= not defined!");
}

# end of main



sub add {

  $form->{title} = "Add";
  $form->{charttype} = "A";
  $form->{callback} = "$form->{script}?action=list&path=$form->{path}&login=$form->{login}";

  &form_header;
  &form_footer;
  
}


sub edit {
  $form->{title} = "Edit";

  AM->get_tuple(\%myconfig, \%$form);
  
  foreach my $item (split(/:/, $form->{link})) {
    $form->{$item} = "checked";
  }


  &form_header;
  &form_footer;

}


sub form_header {

  $form->{title} = $locale->text("$form->{title} Account");
  
  $form->header;
  
  $checked{$form->{charttype}} = "checked";
  $checked{"$form->{category}_"} = "checked";
  $checked{CT_tax} = ($form->{CT_tax}) ? "" : "checked";
  
  $form->{description} =~ s/"/&quot;/g;

# this is for our parser only!
# class=submit type=submit $locale->text('Add Account')
# class=submit type=submit $locale->text('Edit Account')

  print qq|

<h2>$form->{title}</h2>

<form method=post action=$form->{script}>

<input type=hidden name=id value=$form->{id}>

<input type=hidden name=inventory_accno_id value=$form->{inventory_accno_id}>
<input type=hidden name=income_accno_id value=$form->{income_accno_id}>
<input type=hidden name=expense_accno_id value=$form->{expense_accno_id}>

<input type=hidden name=amount value=$form->{amount}>

<table border=1>
<tr valign=top>
<td>
<table>

<tr>
  <th align=right>|.$locale->text('Account Number').qq|</th>
  <td><input name=accno size=9 maxlength=9 value=$form->{accno}></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Description').qq|</th>
  <td colspan=3><input name=description size=40 value="$form->{description}"></td>
</tr>

<tr>
  <th align=right valign=top>|.$locale->text('Account Type').qq|</th>
  <td colspan=3>
  <table>
    <tr valign=top>
      <td>
      <input name=category class=radio type=radio value=A $checked{A_}> |.$locale->text('Asset').qq|
      <br><input name=category class=radio type=radio value=L $checked{L_}> |.$locale->text('Liability').qq|
      <br><input name=category class=radio type=radio value=Q $checked{Q_}> |.$locale->text('Equity').qq|
      <br><input name=category class=radio type=radio value=I $checked{I_}> |.$locale->text('Income').qq|
      <br><input name=category class=radio type=radio value=E $checked{E_}> |.$locale->text('Expense').qq|
      </td>

      <td width=50>&nbsp;</td>

      <td>
      <input name=charttype class=radio type=radio value="H" $checked{H}> |.$locale->text('Heading').qq|
      <br><input name=charttype class=radio type=radio value="A" $checked{A}> |.$locale->text('Account').qq|
      </td>
    </tr>
  </table>

  </td>
</tr>

|;


if ($form->{charttype} eq "A") {
  print qq|
<tr>
  <td colspan=4><b>|.$locale->text('Is this a summary account to record').qq|</b>
  <input name=AR class=checkbox type=checkbox value=AR $form->{AR}> |.$locale->text('AR').qq|
  <input name=AP class=checkbox type=checkbox value=AP $form->{AP}> |.$locale->text('AP').qq|
  <input name=IC class=checkbox type=checkbox value=IC $form->{IC}> |.$locale->text('Inventory').qq|
  </td>
</tr>

<tr>
  <th colspan=4>|.$locale->text('Include in drop-down menus').qq|</th>
</tr>

<tr valign=top>
  <td><b>|.$locale->text('Receivables').qq|</b>
  <br><input name=AR_amount class=checkbox type=checkbox value=AR_amount $form->{AR_amount}> |.$locale->text('Income').qq|
  <br><input name=AR_paid class=checkbox type=checkbox value=AR_paid $form->{AR_paid}> |.$locale->text('Deposit').qq|
  <br><input name=AR_tax class=checkbox type=checkbox value=AR_tax $form->{AR_tax}> |.$locale->text('Tax').qq|
  </td>

  <td><b>|.$locale->text('Payables').qq|</b>
  <br><input name=AP_amount class=checkbox type=checkbox value=AP_amount $form->{AP_amount}> |.$locale->text('Expense/Asset').qq|
  <br><input name=AP_paid class=checkbox type=checkbox value=AP_paid $form->{AP_paid}> |.$locale->text('Payment').qq|
  <br><input name=AP_tax class=checkbox type=checkbox value=AP_tax $form->{AP_tax}> |.$locale->text('Tax').qq|
  </td>

  <td><b>|.$locale->text('Parts Inventory').qq|</b>
  <br><input name=IC_sale class=checkbox type=checkbox value=IC_sale $form->{IC_sale}> |.$locale->text('Sales').qq|
  <br><input name=IC_cogs class=checkbox type=checkbox value=IC_cogs $form->{IC_cogs}> |.$locale->text('COGS').qq|
  <br><input name=IC_taxpart class=checkbox type=checkbox value=IC_taxpart $form->{IC_taxpart}> |.$locale->text('Tax').qq|
  </td><td><b>|.$locale->text('Service Items').qq|</b>
  <br><input name=IC_income class=checkbox type=checkbox value=IC_income $form->{IC_income}> |.$locale->text('Income').qq|
  <br><input name=IC_expense class=checkbox type=checkbox value=IC_expense $form->{IC_expense}> |.$locale->text('Expense').qq|
  <br><input name=IC_taxservice class=checkbox type=checkbox value=IC_taxservice $form->{IC_taxservice}> |.$locale->text('Tax').qq|
  </td>
</tr>
|;
}

print qq|
<tr>
<th align=left colspan=3><b>|.$locale->text('Include this account on the customer/vendor forms to flag customer/vendor as taxable?').qq|</th>
<td><input name=CT_tax class=radio type=radio value=CT_tax $form->{CT_tax}>&nbsp;Yes
<input name=CT_tax class=radio type=radio value="" $checked{CT_tax}>&nbsp;No</td>
</tr>

<tr>
<th align=right>|.$locale->text('GIFI Code').qq|</th>
<td colspan=3><input name=gifi size=4 maxlength=4 value=$form->{gifi}></td>
</tr>

</table>
</td>
|;

}


sub form_footer {

  print qq|

<input name=callback type=hidden value="$form->{callback}">

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>

</table>

<input class=submit type=submit name=action value="|.$locale->text('Save Account').qq|">
|;

  if ($form->{id}) {
    print qq|<input class=submit type=submit name=action value="|.$locale->text('Delete Account').qq|">|;
  }

  print "</form>";

}


sub save_account {

  $form->isblank("accno", $locale->text('Account Number missing!'));
  $form->isblank("category", $locale->text('Account Type missing!'));
  
  $form->isposted(AM->save_account(\%myconfig, \%$form, $userspath));

}


sub list {

  CA->all_accounts(\%myconfig, \%$form);

  $form->{title} = $locale->text('Chart of Accounts');
  
  # construct callback
  $callback = "$form->{script}?action=list&path=$form->{path}&login=$form->{login}";


  $form->header;

  print qq|
<h2>$form->{title}</h2>

<table border=1>
<tr bgcolor=000000>
<th><font color=ffffff>|.$locale->text('Account').qq|</a></th>
<th><font color=ffffff>|.$locale->text('Description').qq|</a></th>
<th><font color=ffffff>|.$locale->text('Debit').qq|</a></th>
<th><font color=ffffff>|.$locale->text('Credit').qq|</a></th>
<th><font color=ffffff>|.$locale->text('Link').qq|</a></th>
</tr>
|;

  # escape callback
  $callback = $form->escape($callback);
  
  foreach $ca (@{ $form->{CA} }) {
    
    $ca->{debit} = "&nbsp;";
    $ca->{credit} = "&nbsp;";

    $amount = 0;
    
    if ($ca->{amount} > 0) {
      $ca->{credit} = $form->format_amount(\%myconfig, $ca->{amount});
      $amount = $ca->{credit};
    }
    if ($ca->{amount} < 0) {
      $ca->{debit} = $form->format_amount(\%myconfig, -$ca->{amount});
      $amount = $ca->{debit};
    }

    $ca->{link} =~ s/:/<br>/og;
    $ca->{link} .= "&nbsp;";

    if ($ca->{charttype} eq "H") {
      print qq|<tr bgcolor=336666>
<th><a href=$form->{script}?action=edit&id=$ca->{id}&path=$form->{path}&login=$form->{login}&callback=$callback><font color=ffffff>$ca->{accno}</th>
<th><font color=ffffff>$ca->{description}</th>
<th><font color=ffffff>&nbsp;</th>
<th><font color=ffffff>&nbsp;</th>
<th><font color=ffffff>&nbsp;</th>
</tr>|;

    } else {
      print qq|
<tr valign=top>
<td><a href=$form->{script}?action=edit&id=$ca->{id}&path=$form->{path}&login=$form->{login}&callback=$callback&amount=$amount>$ca->{accno}</td>
<td>$ca->{description}</td>
<td align=right>$ca->{debit}</td>
<td align=right>$ca->{credit}</td>
<td>$ca->{link}</td>
</tr>|;
    }
  }
  
  print qq|
</table>

<br>|.$locale->text('Click on account number to edit');

}


sub delete_account {

  $form->{title} = $locale->text('Delete Account');

  if ($form->{amount} != 0) {  
    $form->error($locale->text('Transactions exist; cannot delete account'));
  }

  foreach $id (qw(inventory_accno_id income_accno_id expense_accno_id)) {
    if ($form->{id} == $form->{$id}) {
      $form->error($locale->text('Cannot delete default account'));
    }
  }

  $form->isdeleted(AM->delete_account(\%myconfig, \%$form, $userspath));

}



# generate setup menu
sub setup_menu {

  $form->{title} = $locale->text('Setup Menu');
  
  print qq|Content-type: text/html

<head>
  <title>$form->{title}</title>
</head>

<body bgcolor="#FBFFE7">

<font size=-1>
<b>$form->{title}</b>

<p><b>|.$locale->text('Accounts').qq|</b>
<li><a href=$form->{script}?action=add&path=$form->{path}&login=$form->{login} target=main_window>|.$locale->text('Add').qq|</a>
<li><a href=$form->{script}?action=list&path=$form->{path}&login=$form->{login} target=main_window>|.$locale->text('List').qq|</a>

<p><b>|.$locale->text('Templates').qq|</b>
<li><a href=$form->{script}?action=display_form&file=$myconfig{templates}/income_statement.html&path=$form->{path}&login=$form->{login} target=main_window>|.$locale->text('Income Statement').qq|</a>
<li><a href=$form->{script}?action=display_form&file=$myconfig{templates}/balance_sheet.html&path=$form->{path}&login=$form->{login} target=main_window>|.$locale->text('Balance Sheet').qq|</a>
<li><a href=$form->{script}?action=display_form&file=$myconfig{templates}/invoice.html&path=$form->{path}&login=$form->{login} target=main_window>|.$locale->text('Invoice').qq|</a>
<li><a href=$form->{script}?action=display_form&file=$myconfig{templates}/email_invoice.html&path=$form->{path}&login=$form->{login} target=main_window>|.$locale->text('E-mail Invoice').qq|</a>
<li><a href=$form->{script}?action=display_form&file=$myconfig{templates}/packing_list.html&path=$form->{path}&login=$form->{login} target=main_window>|.$locale->text('Packing List').qq|</a>

<p><b>|.$locale->text('Configuration').qq|</b>
<li><a href=$form->{script}?action=config&path=$form->{path}&login=$form->{login} target=main_window>|.$locale->text('Preferences').qq|</a>

|;
}



sub display_form {

  AM->load_template(\%$form);

  $form->{title} = $form->{file};

  $form->header;

  print qq|
$form->{body}

<form method=post action=$form->{script}>

<input name=file type=hidden value=$form->{file}>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>

<input name=action class=submit type=submit value="|.$locale->text('Edit Template').qq|">
</form>
|;

}


sub edit_template {

  AM->load_template(\%$form);

  # convert &nbsp to &amp;nbsp;
  $form->{body} =~ s/&nbsp;/&amp;nbsp;/g;
  
  $form->{title} = $locale->text('Edit Template');

  $form->header;
  
  print qq|

<form method=post action=$form->{script}>

<input name=file type=hidden value=$form->{file}>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>

<input name=callback type=hidden value="$form->{script}?action=display_form&file=$form->{file}&path=$form->{path}&login=$form->{login}">

<textarea name=body rows=25 cols=70>
$form->{body}
</textarea>

<br>
<input class=submit type=submit name=action value="|.$locale->text('Save Template').qq|">

</form>
|;

}



sub save_template {

  AM->save_template(\%$form);

  $form->redirect;
  
}


sub config {

  # get defaults for account numbers and last numbers
  AM->defaults(\%myconfig, \%$form, $userspath);

  foreach $item (qw(yy-mm-dd mm-dd-yy mm/dd/yy dd-mm-yy dd/mm/yy dd.mm.yy)) {
    $dateformat .= ($item eq $myconfig{dateformat}) ? "<option selected>$item\n" : "<option>$item\n";
  }

  foreach $item (qw(1,000.00 1000.00 1.000,00 1000,00)) {
    $numberformat .= ($item eq $myconfig{numberformat}) ? "<option selected>$item\n" : "<option>$item\n";
  }


  foreach $item (qw(name company address signature shippingpoint)) {
    $myconfig{$item} =~ s/"/&quot;/g;
  }

  foreach $item (qw(address signature)) {
    $myconfig{$item} =~ s/\\n/\n/g;
  }

  %countrycodes = (split /:/, $countrycodes);
  $countrycodes = '';
  foreach $key (sort keys %countrycodes) {
    $countrycodes .= ($key eq $myconfig{countrycode}) ? "<option selected>$key--$countrycodes{$key}\n" : "<option>$key--$countrycodes{$key}\n";
  }

  foreach $key (keys %{ $form->{IC} }) {
    foreach $accno (sort keys %{ $form->{IC}{$key} }) {
      $myconfig{$key} .= ($form->{IC}{$key}{$accno}{id} == $form->{defaults}{$key}) ? "<option selected>$accno--$form->{IC}{$key}{$accno}{description}\n" : "<option>$accno--$form->{IC}{$key}{$accno}{description}\n";
    }
  }
  

  $form->{title} = $locale->text('Edit Preferences for') . " $form->{login}";
  
  $form->header;
  
  print qq|
<h2>$form->{title}</h2>

<form method=post action=$form->{script}>

<input type=hidden name=login value=$myconfig{login}>
<input type=hidden name=old_password value=$myconfig{password}>

<table border=1><tr><td>

<table>
<tr>
  <th align=right>|.$locale->text('Name').qq|</th>
  <td><input name=name size=15 value="$myconfig{name}">
  <b>|.$locale->text('Password').qq|</b>
  <input type=password name=password size=10 value=$myconfig{password}></td>
</tr>

<tr>
  <th align=right>|.$locale->text('E-mail').qq|</th>
  <td><input name=email size=30 value=$myconfig{email}></td>
</tr>

<tr valign=top>
  <th align=right>|.$locale->text('Signature').qq|</th>
  <td><textarea name=signature rows=3 cols=30>$myconfig{signature}</textarea></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Phone').qq|</th>
  <td><input name=tel size=14 value="$myconfig{tel}">
  <b>|.$locale->text('Fax').qq|</b>
  <input name=fax size=14 value="$myconfig{fax}"></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Company').qq|</th>
  <td><input name=company size=30 value="$myconfig{company}"></td>
</tr>

<tr valign=top>
  <th align=right>|.$locale->text('Address').qq|</th>
  <td><textarea name=address rows=3 cols=30>$myconfig{address}</textarea></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Date Format').qq|</th>
  <td><select name=dateformat>$dateformat</select>
  </td>
</tr>

<tr>
  <th align=right>|.$locale->text('Number Format').qq|</th>
  <td><select name=numberformat>$numberformat</select>
  </td>
</tr>

<tr>
  <th align=right>|.$locale->text('Language').qq|</th>
  <td><select name=countrycode>$countrycodes</select></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Character Set').qq|</th>
  <td><input name=charset size=20 value="$myconfig{charset}"></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Stylesheet').qq|</th>
  <td><input name=stylesheet size=20 value="$myconfig{stylesheet}"></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Printer').qq|</th>
  <td><input name=printer size=20 value="$myconfig{printer}"></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Shipping Point').qq|</th>
  <td><input name=shippingpoint size=25 value="$myconfig{shippingpoint}"></td>
</tr>

<tr bgcolor=336666>
  <th colspan=2>&nbsp;</th>
</tr>

<tr>
  <th align=right>|.$locale->text('Business Number').qq|</th>
  <td><input name=businessnumber size=25 value="$myconfig{businessnumber}"></td>
</tr>

<tr>
  <th align=right>|.$locale->text('Year End').qq| (mm/dd)</th>
  <td><input name=yearend size=5 maxsize=5 value=$form->{defaults}{yearend}>
  <b>|.$locale->text('Currency').qq|</b>
  <input name=nativecurr size=3 value="$form->{defaults}{nativecurr}">
  <b>|.$locale->text('Weight Unit').qq|</b>
  <input name=weightunit size=5 value="$form->{defaults}{weightunit}">
  </td>
</tr>

<tr bgcolor=336666>
  <th colspan=2><font color=ffffff>|.$locale->text('Last Numbers & Default Accounts').qq|</font></th>
</tr>

<tr>
  <td colspan=2>
  
  <table border=0>
  <tr>
  <th align=right>|.$locale->text('Inventory Account').qq|</th>
  <td><select name=inventory_accno>$myconfig{IC}</select></td>
  </tr>

  <tr>
  <th align=right>|.$locale->text('Income Account').qq|</th>
  <td><select name=income_accno>$myconfig{IC_income}</select></td>
  </tr>

  <tr>
  <th align=right>|.$locale->text('Expense Account').qq|</th>
  <td><select name=expense_accno>$myconfig{IC_expense}</select></td>
  </tr>

  <tr>
  <th align=right>|.$locale->text('Last Invoice Number').qq|</th>
  <td><input name=invnumber size=10 value=$form->{defaults}{invnumber}></td>
  </tr>

  <tr>
  <th align=right>|.$locale->text('Last PO Number').qq|</th>
  <td><input name=ponumber size=10 value=$form->{defaults}{ponumber}></td>
  </tr>
  
  </table>
  </td>
</tr>

<tr bgcolor=336666>
  <th colspan=2><font color=ffffff>|.$locale->text('Tax Accounts').qq|</font></th>
</tr>

<tr>
  <td colspan=2>
  <table>
  
  <tr>
    <th>&nbsp;</th><th>|.$locale->text('Rate').qq| (%)</th><th>|.$locale->text('Number').qq|</th>
  </tr>
|;

  
  foreach $accno (sort keys %{ $form->{taxrates} }) {
    print qq|
    <tr>
    <th align=right>$form->{taxrates}{$accno}{description}</th>
    <td><input name=$form->{taxrates}{$accno}{id} size=6 value=$form->{taxrates}{$accno}{rate}></td>
    <td><input name="taxnumber_$form->{taxrates}{$accno}{id}" value="$form->{taxrates}{$accno}{taxnumber}"></td>
    </tr>
|;
    $form->{taxaccounts} .= "$form->{taxrates}{$accno}{id} ";
  }

  chop $form->{taxaccounts};

  print qq|
<input name=taxaccounts type=hidden value="$form->{taxaccounts}">

</table>

</tr>

</table>

</td></tr></table>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>

<input class=submit type=submit name=action value="|.$locale->text('Save Preferences').qq|">
</form>

<table><tr><td>
|;

}


sub save_preferences {

  AM->save_preferences(\%myconfig, \%$form, $memberfile, $userspath);

  $form->{title} = $locale->text('Preferences saved!');

  $form->header;

  print "<h2>$form->{title}</h2>";

}


