#!/usr/bin/perl

if (!open (FILE, $ARGV[0])) {
  print "ERROR: $!\n";
  exit;
}
else {
  @buffer = <FILE>;
  close FILE;
}

foreach $line (@buffer) {
  chomp $line;
  my ($option, $value) = split(/: /, $line);
  $config{$option} = $value;
}

if ($config{Media} eq "Text") {
  open(LOG, ">>$config{File}");
}
elsif ($config{Media} eq "Database") {
  use DBI;
  my $connect_string = "DBI:" . $config{'DB type'} . ":" . $config{'DB name'};
  $connect_string = $connect_string . ":" . $config{'DB host'} if ($config{'DB host'});
  $connect_string = $connect_string . ":" . $config{'DB port'} if ($config{'DB port'});
  $database = DBI->connect($connect_string, $config{'DB username'}, $config{'DB password'});
  $add_event = $database->prepare("INSERT INTO $config{'Table'} (Method, Object, Host, Response, Remote, Info) VALUES (?, ?, ?, ?, ?, ?)");
}

while ($buffer ne "CONTROL TERMINATE") {
  my $buffer = <STDIN>;
  #print $buffer;
  chomp $buffer;
  my @words = split(/\t/, $buffer);
  my $command = shift @words;

  if ($command eq "INSERT") {
    unless ($add_event->execute(@words)) {
      print "Log error: $database->error\n";
    }
  }
}
